/**
 * CSE 154
 * Lab 7 (Regex and Form Validation)
 * Starter JS for E-Pizzeria exercise
 */
(function() {
  "use strict";

  // sets up validation checker to send a POST request to your
  // epizzeria.php file
  window.onload = function() {
    $("order-form").onsubmit = function(event) {
      event.preventDefault();
      validateOrder();
    }
  };

  function validateOrder() {
    var toppings = getToppings();
    var cheeses = getCheeses();
    var crust = $$("input[name='crust']:checked");
    var sauce = $$("input[name='sauce']:checked");
    var size = $$("input[name='size']:checked");
    var params = new FormData();
    params.append("tip", $("tip").value);
    params.append("address", $("address").value);
    params.append("city", $("city").value);
    params.append("state", $("state").value);
    params.append("toppings", toppings);
    params.append("cheeses", cheeses);
    params.append("crust", crustt.value);
    params.append("sauce", sauce.value);
    params.append("size", size.value);

    var xhr = new XMLHttpRequest();
    xhr.open("POST", "epizzeria.php");
    xhr.onload = function() {
      // make these messages more fancy
      $("order-results").innerHTML = this.responseText;
    };
    xhr.onerror = function() {
      // make these messages more fancy
      $("order-result").innerHTML = this.responseText;
    };
    xhr.send(params);
  }

  function getCheeses() {
    var arr = array();
    var selectedCheeses = $$("input[name='cheese']:checked");
    for (var i = 0; i < selectedCheeses.length; i++) {
      arr.push(selectedCheeses.value);
    }
    return arr;
  }

  function getToppings() {
    var arr = array();
    var selectedToppings = $$("input[name='topping']:checked");
    for (var i = 0; i < selectedToppings.length; i++) {
      arr.push(selectedToppings.value);
    }
    return arr;
  }


  // ------------------------- Helper Functions ------------------------- // 
  /**
   * Returns DOM element with the given ID.
   */
  function $(id) {
    return document.getElementById(id);
  }
  
  /**
   * Returns an array of DOM elements matching given query selector, or
   * a single element if exactly one element matches the selector.
   */
  function $$(sel) {
    var elements = document.querySelectorAll(sel);
    return elements.length == 1 ? elements[0] : elements;
  }
})();
