/**
 * CSE 154
 * Lab 7 (Regex and Form Validation)
 * Starter JS for E-Pizzeria exercise
 */
(function() {
  "use strict";

  // sets up validation checker (necessary to use HTML5 form validation without a form
  // tag)
  window.onload = function() {

    // we need to do this to avoid unwanted default form behavior 
    // (we don't go over forms in depth in this class)
    $("order-form").onsubmit = function(event) {
      event.preventDefault();
      return false;
    }
  };


  // ------------------------- Helper Functions ------------------------- // 
  /**
   * Returns DOM element with the given ID.
   */
  function $(id) {
    return document.getElementById(id);
  }
  
  /**
   * Returns an array of DOM elements matching given query selector, or
   * a single element if exactly one element matches the selector.
   */
  function $$(sel) {
    var elements = document.querySelectorAll(sel);
    return elements.length == 1 ? elements[0] : elements;
  }
})();
